// FuncExtDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FuncExtDemo.h"
#include "FuncExtDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFuncExtDemoDlg dialog

CFuncExtDemoDlg::CFuncExtDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFuncExtDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFuncExtDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFuncExtDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFuncExtDemoDlg)
	DDX_Control(pDX, IDC_CBOFUNCTIONS, m_cboFunctions);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFuncExtDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CFuncExtDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CHOOSELIBRARY, OnChooselibrary)
	ON_BN_CLICKED(IDC_FINDFUNC, OnFindfunc)
	ON_CBN_SELCHANGE(IDC_CBOFUNCTIONS, OnSelchangeCbofunctions)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFuncExtDemoDlg message handlers

BOOL CFuncExtDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	RefreshDlg();



	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFuncExtDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFuncExtDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFuncExtDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFuncExtDemoDlg::OnChooselibrary() 
{
	CString strFilter="Library files (*.dll)|*.dll|All Files (*.*)|*.*||";
    CFileDialog  dlg(TRUE,_T(".dll"),NULL,
		 OFN_OVERWRITEPROMPT|OFN_FILEMUSTEXIST,
		 (LPCTSTR)strFilter); 
    dlg.m_ofn.lpstrTitle=_T("Choose library file");
	
    if (dlg.DoModal()==IDOK)
	{
		CString path = dlg.GetPathName();
		if (!path.GetLength())
			return;

		BOOL bLoaded = m_Lib.Load(path,FALSE,FALSE); // full path name
		if (bLoaded)
		{
			RefreshDlg();
			GetDlgItem(IDC_LIBRARY)->SetWindowText(path);
			GetDlgItem(IDC_FINDFUNC)->EnableWindow(TRUE);
			GetDlgItem(IDC_EDITFUNCNAME)->EnableWindow(TRUE);
			GetDlgItem(IDC_CBOFUNCTIONS)->EnableWindow(TRUE);
		}
	}
}

void CFuncExtDemoDlg::OnFindfunc() 
{
	CString strFuncName;
	GetDlgItem(IDC_EDITFUNCNAME)->GetWindowText(strFuncName);
	if (!strFuncName.GetLength())
		return;

	BOOL bFoundProc = m_Lib.AddProc(strFuncName,TRUE);
	if (bFoundProc)
		m_cboFunctions.AddString(strFuncName);
}

void CFuncExtDemoDlg::RefreshDlg()
{
	m_cboFunctions. ResetContent();
	m_cboFunctions.SetCurSel(-1);
	GetDlgItem(IDC_ADDRESS)->SetWindowText(_T(""));
	GetDlgItem(IDC_FUNCNAME)->SetWindowText(_T(""));
	GetDlgItem(IDC_EDITFUNCNAME)->SetWindowText(_T(""));
	GetDlgItem(IDC_LIBRARY)->SetWindowText(_T(""));

	GetDlgItem(IDC_FINDFUNC)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDITFUNCNAME)->EnableWindow(FALSE);
	GetDlgItem(IDC_CBOFUNCTIONS)->EnableWindow(FALSE);
}

void CFuncExtDemoDlg::OnSelchangeCbofunctions() 
{
	int nIndex = m_cboFunctions.GetCurSel();
	if (nIndex==CB_ERR || nIndex==-1)
	{
		GetDlgItem(IDC_ADDRESS)->SetWindowText(_T(""));
		GetDlgItem(IDC_FUNCNAME)->SetWindowText(_T(""));
		return;
	}
	CString strFunc;
	m_cboFunctions.GetLBText(nIndex,strFunc);
	if (!strFunc.GetLength())
		return; //NULL length function

	FARPROC farProc = m_Lib.GetProc(strFunc,TRUE);
	if (farProc == NULL)
		return;

	CString strAddress;
	strAddress.Format("%p",farProc);

	GetDlgItem(IDC_ADDRESS)->SetWindowText(strAddress);
	GetDlgItem(IDC_FUNCNAME)->SetWindowText(strFunc);

}
