// LibraryFuncExtractor.h: interface for the CLibraryFuncExtractor class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LIBRARYFUNCEXTRACTOR_H__34EDE8C5_DA51_11D4_B8C5_A1BC69D1B745__INCLUDED_)
#define AFX_LIBRARYFUNCEXTRACTOR_H__34EDE8C5_DA51_11D4_B8C5_A1BC69D1B745__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "LoadLibrary.h"
#include <afxcoll.h>

class CLibraryFuncExtractor : public CLoadLibrary  
{
public:
	CLibraryFuncExtractor() : CLoadLibrary() { }
	// 2 constructors calling base constructor
	CLibraryFuncExtractor(LPCTSTR lpszFileName) : CLoadLibrary(lpszFileName) { }
	CLibraryFuncExtractor(LPCTSTR lpszFileName,BOOL bSystemDirectory,BOOL bWindowsDirectory) 
		: CLoadLibrary(lpszFileName,bSystemDirectory,bWindowsDirectory) { }

	virtual ~CLibraryFuncExtractor();

	// returns the number of inserted functions
	int Add(int nCount,LPCTSTR *lpszProcName);
	BOOL AddProc(LPCTSTR lpszProcName,BOOL bRefreshAddress=FALSE);
	FARPROC GetProc(LPCTSTR lpszProcName,BOOL bLookUpIfNotInMap=TRUE);

protected:

	CMapStringToPtr m_MapStringToPtr;
};

#endif // !defined(AFX_LIBRARYFUNCEXTRACTOR_H__34EDE8C5_DA51_11D4_B8C5_A1BC69D1B745__INCLUDED_)
