// LoadLibrary.h: interface for the CLoadLibrary class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LOADLIBRARY_H__20859F61_C476_11D4_B8C5_AC5C431AEE47__INCLUDED_)
#define AFX_LOADLIBRARY_H__20859F61_C476_11D4_B8C5_AC5C431AEE47__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CLoadLibrary  
{
public:
	CLoadLibrary();
	CLoadLibrary(LPCTSTR lpszFileName);
	CLoadLibrary(LPCTSTR lpszFileName,BOOL bSystemDirectory,BOOL bWindowsDirectory);
	~CLoadLibrary();

	BOOL Load(LPCTSTR lpszFileName,BOOL bSystemDirectory=FALSE,BOOL bWindowsDirectory=FALSE);

	BOOL IsLoaded() { return hInstance!=NULL; }
	HINSTANCE GetInstance() { return hInstance; }
	CString GetLibrary() { return m_strLibrary; }

protected:
	void Free();
	FARPROC FindProc(LPCTSTR lpszProcName);

private:
	HINSTANCE  hInstance;
	CString  m_strLibrary;
};

#endif // !defined(AFX_LOADLIBRARY_H__20859F61_C476_11D4_B8C5_AC5C431AEE47__INCLUDED_)
